package org.greenstone.gsdl3.gs3build.xpointer;

import org.w3c.dom.*;
import org.apache.xpath.*;

public class IdentifierXPointer extends XPointer
{ NodeList nodes;

  public IdentifierXPointer(Document document, String xpointer)
  { super(document, xpointer);

    this.xpointer = XPointer.expandXPath(this.xpointer);

    this.nodes = this.getNodes();
  }

  private NodeList getNodes()
  {
    try {
      NodeList nodes = XPathAPI.selectNodeList(this.document, this.xpointer, 
					       this.document.getDocumentElement());
      return nodes;
    }
    catch (Exception ex)
    { System.out.println(ex.toString());
    }
    return null;
  }

  public Node getStartNode()
  { return this.nodes.item(0);
  }

  private void recurseStringify(NodeList nodes, StringBuffer buffer)
  { 
    for (int n = 0; n < nodes.getLength(); n ++) {
      Node node = nodes.item(n);

      // append the actual node itself
      this.printNode(node, buffer, false);

      // then process its children...
      if (node.getNodeType() == org.w3c.dom.Node.ELEMENT_NODE) {
	NodeList children = node.getChildNodes();
	this.recurseStringify(children, buffer);
      }

      // do the close node
      this.printNode(node, buffer, true);
    }
  }

  public String toString()
  {
    StringBuffer reply = new StringBuffer();
    this.recurseStringify(this.nodes, reply);
    return reply.toString();
  }
}
